unit m3u_2_flash;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Grids, Queue_Unit, Menus, QDialogs, perevod_v_kirillicu_Unit;


type
  QFile = record
    Name, Size, Path: TQueue;
  end;
  TForm1 = class(TForm)       //  
    OpenDialog1: TOpenDialog;
    Button1: TButton;
    Label1: TLabel;
    StringGrid1: TStringGrid;
    Label2: TLabel;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Label3: TLabel;
    Label4: TLabel;
    CheckBox1: TCheckBox;
    Button6: TButton;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    Label5: TLabel;
    Label6: TLabel;
    CheckBox5: TCheckBox;
    Button7: TButton;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure StringGrid1SelectCell(Sender: TObject; ACol, ARow: Integer;
      var CanSelect: Boolean);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure CheckBox3Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  Queue: QFile;
  SizeAll, Size, DiskSizeFree: Real;
  XRow: Integer; // Col - , Row - 
  DirPath: WideString;
  PlayListPath: string;
  MP3_only: boolean;

implementation

uses about;

{$R *.dfm}
{$I-}

procedure Clear_Queue;
begin
Queue.Name.Clear;
Queue.Size.Clear;
Queue.Path.Clear;
Form1.StringGrid1.RowCount:=2;
Form1.StringGrid1.Cells[0, 1]:='';
Form1.StringGrid1.Cells[1, 1]:='';
Form1.StringGrid1.Cells[2, 1]:='';
Form1.Label2.Caption:='';
end;


function obrabotka_adresa(Str: string; Path: string):string;
var C: char;
  Res: string;
begin
C:=Str[2];
if C=':'
  then  //  C:\papka\fail.mp3
    begin
      if FileExists(Str) then Res:=Str
        else Res:='Error';
    end
  else
    begin
      C:=Str[1];
      if C='\'
        then  //  \papka\fail.mp3
          begin
            Path:=copy(Path, 1, 2);
            Res:=Path+Str;
          end
        else  //  fail.mp3
          begin
            Path:=ExtractFilePath(Path);
            Res:=Path+Str;
          end;
    end;
if FileExists(Res) then Result:=Res
  else Result:='Error';
end;

procedure Add_string(file_path: string);
  var F: TSearchRec;
    Res: Integer;
begin
F.Name:='';   //       
Res:=FindFirst(ExtractFilePath(file_path)+'*'+ExtractFileExt(file_path), faAnyFile, F);
while (Res=0) and (F.Name<>ExtractFileName(file_path)) do
  begin
    Res:=FindNext(F);
  end;
FindClose(F);   //  
Size:=Round(F.Size*100/1048576)/100;
Queue.Name.Push(ExtractFileName(file_path));
Queue.Size.Push(FloatToStr(Size));
Queue.Path.Push(file_path);
SizeAll:=SizeAll+Size;
end;

procedure Move_to_table;
  var N, i: Integer;
    Size_S, FileName: string;
begin
SizeAll:=0;
N:=Queue.Name.GetLength;
if N>0
  then  //    
    begin
      Form1.StringGrid1.RowCount:=N+1;
      i:=1;
      Queue.Size.ResetLook;
      Queue.Name.ResetLook;
      while not Queue.Name.LookEnd do
        begin
          FileName:=Queue.Name.LookNext;
          Size_S:=Queue.Size.LookNext;
          if ( (LowerCase(ExtractFileExt(FileName))='.mp3') or (not MP3_only) )
          then
            begin
              Form1.StringGrid1.Cells[0, i]:=IntToStr(i);
              Form1.StringGrid1.Cells[1, i]:=FileName;
              Form1.StringGrid1.Cells[2, i]:=Size_S;
                if Size_S<>' !'
                  then SizeAll:=SizeAll+StrToFloat(Size_S);
              i:=i+1;
            end;
        end;
      Form1.StringGrid1.RowCount:=i;
      Form1.Label2.Caption:='  : '+FloatToStr(SizeAll)+' M';
      Form1.Button6.Enabled:=false;
      if ( (SizeAll<DiskSizeFree) and (DirPath<>'') )
        then Form1.Button6.Enabled:=true;
    end
  else
    begin
      Form1.Label2.Caption:=' .';
      Form1.StringGrid1.Cells[0, 1]:='';
      Form1.StringGrid1.Cells[1, 1]:='';
      Form1.StringGrid1.Cells[2, 1]:='';
    end;
Form1.Button4.Enabled:=true;
Form1.Button3.Enabled:=true;
end;

procedure chtenie_lista(Path: string);
var F:TextFile;
  Buffer, FilePath: string;
  Flag: Boolean;
begin
Form1.Label4.Caption:='';
Form1.Label3.Caption:=' : ';
Flag:=true;
SizeAll:=0;
Clear_Queue;
AssignFile(F, Path);
Reset(F);
if not EOF(F) then ReadLn(F, Buffer); //   "#EXTM3"
while not EOF(F) do
  begin
    Flag:=not Flag;
    ReadLn(F,Buffer);
    if Flag //     
      then
        begin
          FilePath:=obrabotka_adresa(Buffer, Path); // Buffer -   mp3-  *.m3u, Path -   *.m3u
          if FilePath='Error'
            then  //     -  
              begin
                Queue.Name.Push(Buffer);
                Queue.Size.Push(' !');
                Queue.Path.Push('!!!');
              end
            else  //  
              begin
                Add_string(FilePath);
              end;
        end;
  end;
CloseFile(F);
Move_to_table;
end;



procedure TForm1.Button1Click(Sender: TObject); //   
begin
OpenDialog1.Filter:='WINAMP playlist *.m3u|*.m3u';
if OpenDialog1.Execute()
  then
    begin
      PlayListPath:=OpenDialog1.FileName;
      if (FileExists(PlayListPath))
        then
          begin
            Label1.Caption:=PlayListPath;
            chtenie_lista(PlayListPath);
          end
        else
          Label1.Caption:='.   .   .';
    end;
end; //  TForm1.Button1Click


procedure TForm1.FormCreate(Sender: TObject);
begin
MP3_only:=false;
DirPath:='';
Form1.Button4.Enabled:=false;
Form1.Button3.Enabled:=false;
Form1.StringGrid1.Cells[0, 0]:='';
Form1.StringGrid1.Cells[1, 0]:='';
Form1.StringGrid1.Cells[2, 0]:=', ';
Form1.StringGrid1.RowCount:=2;
Queue.Name:=TQueue.Create;
Queue.Size:=TQueue.Create;
Queue.Path:=TQueue.Create;
Form1.Label1.Caption:='  .';
Form1.Label2.Caption:='';
Form1.Label3.Caption:=' : ';
Form1.Label4.Caption:='';
Form1.Label5.Caption:='';
Form1.Label6.Caption:='';
Form1.Button6.Enabled:=false;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
Queue.Name.Destroy;
Queue.Size.Destroy;
Queue.Path.Destroy;
end;


procedure TForm1.Button2Click(Sender: TObject);
begin
DirPath:='';
Form1.Label4.Caption:='';
Form1.Label3.Caption:=' : ';
Form1.Button4.Enabled:=false;
Form1.Button3.Enabled:=false;
Form1.Button6.Enabled:=false;
Form1.Label1.Caption:='  .';
Clear_Queue;
end;


procedure TForm1.Button4Click(Sender: TObject);
var FilePath: string;
    N: integer;
begin
  OpenDialog1.Filter:='Music (*.mp3, *.wav, *.wma, *.ogg)|*.wav;*.mp3;*.wma;*.ogg';
  if OpenDialog1.Execute()
    then
      begin
        FilePath:=OpenDialog1.FileName;
        if not Queue.Name.Empty then
            Form1.StringGrid1.RowCount:=Form1.StringGrid1.RowCount+1;
        N:=Form1.StringGrid1.RowCount;
        Add_String(FilePath);
        Form1.Label2.Caption:='  : '+FloatToStr(SizeAll)+' ';
        Form1.StringGrid1.Cells[0, N-1]:=IntToStr(N-1);
        Form1.StringGrid1.Cells[1, N-1]:=Queue.Name.LookTail;
        Form1.StringGrid1.Cells[2, N-1]:=Queue.Size.LookTail;
        if ( (SizeAll<DiskSizeFree) and (DirPath<>'') )
          then Form1.Button6.Enabled:=true
          else Form1.Button6.Enabled:=false;
      end;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  Queue.Name.Delete(XRow);
  Queue.Size.Delete(XRow);
  Queue.Path.Delete(XRow);
  Move_to_table;
end;

procedure TForm1.StringGrid1SelectCell(Sender: TObject; ACol,
  ARow: Integer; var CanSelect: Boolean);
begin
  XRow:=ARow;
end;

function DiskFree2(Path: WideString): Real;
  var CurDir: string;
    CurDrive, temp: Char;
    Letter: Integer;
    Size: Int64;
begin
  temp:=Char(Path[1]);
  CurDir:=GetCurrentDir;
  CurDrive:=CurDir[1];
  if temp=CurDrive then Letter:=0
    else
      case temp of
        'A': Letter:=1;
        'B': Letter:=2;
        'C': Letter:=3;
        'D': Letter:=4;
        'E': Letter:=5;
        'F': Letter:=6;
        'G': Letter:=7;
        'H': Letter:=8;
        'I': Letter:=9;
        'J': Letter:=10;
        'K': Letter:=11;
        'L': Letter:=12;
        'N': Letter:=13;
        'M': Letter:=14;
        'O': Letter:=15;
        'P': Letter:=16;
        'Q': Letter:=17;
        'R': Letter:=18;
        'S': Letter:=19;
        'T': Letter:=20;
        'U': Letter:=21;
        'V': Letter:=22;
        'W': Letter:=23;
        'X': Letter:=24;
        'Y': Letter:=25;
        'Z': Letter:=26;
      end;
  Size:=DiskFree(Letter);
  Result:=Round(Size/10485)/100;
end;

procedure TForm1.Button5Click(Sender: TObject);
  const text='    mp3-:';
    text2='  : ';
begin
  if SelectDirectory(text, '', DirPath)    
    then
    begin
      if DirectoryExists(DirPath)
        then
          begin
            Form1.Label3.Caption:=' : '+DirPath;
            DiskSizeFree:=DiskFree2(DirPath);
            Form1.Label4.Caption:=text2+FloatToStr(DiskSizeFree)+' .';
            if ( (SizeAll<DiskSizeFree) and (DirPath<>'') )
              then Form1.Button6.Enabled:=true
              else Form1.Button6.Enabled:=false;
          end
        else
          begin
            Form1.Label3.Caption:='  .   .';
            Form1.Button6.Enabled:=false;
          end;
    end;
end;

procedure TForm1.Button6Click(Sender: TObject);
  const Oshibka='     ';
    copy_process=' : ';
  var MPL: TextFile;
    Res: Integer;
    MPL_FileName, MPL_path, temp, New_File_Path, DirName, temp_n : string;
    backup_DirPath, Group_Name: string;
    bang, fail: boolean;
begin
backup_DirPath:=DirPath;
bang:=true;
if DirPath='' then   //    
  begin
    bang:=false;
    ShowMessage('!');
  end;
if bang
  then if DirPath[Length(DirPath)]<>'\'
    then DirPath:=Concat(DirPath, '\'); 
if (Form1.CheckBox2.Checked) and (bang) then
  begin
    DirName:=ExtractFileName(PlayListPath);      //     
    Delete(DirName, Length(DirName)-3, 4);       
    if CheckBox4.Checked
      then DirName:=perevod_v_kirillicu(DirName);
    if not DirectoryExists(Concat(DirPath,DirName))
      then
        begin
          DirPath:=Concat(DirPath, DirName, '\');
          CreateDir(DirPath);
        end
      else
        begin
          ShowMessage('     .');
          Form1.CheckBox2.Checked:=false;
          bang:=false;
        end;
  end;
if ( (Form1.CheckBox1.Checked) and (bang) ) then  //     Siemens SL45   *.mpl
  begin
    MPL_FileName:=ExtractFileName(PlayListPath);
    Delete(MPL_FileName, Length(MPL_FileName)-3, 4);
    if CheckBox4.Checked
      then MPL_FileName:=Perevod_v_Kirillicu(MPL_FileName);
    Group_Name:=concat(MPL_FileName, '_');
    MPL_FileName:=Concat(MPL_FileName, '.mpl');
    MPL_path:=Concat(DirPath, MPL_FileName);
    AssignFile(MPL, MPL_path);
    Rewrite(MPL);
    Res:=IOResult;
    if (Res=0)
      then
        begin
          Queue.Name.ResetLook;
          Queue.Size.ResetLook;
          Queue.Path.ResetLook;
          While not Queue.Path.LookEnd do
            begin
              temp:=Queue.Path.LookNext;
              if temp<>'!!!' then    //    -  
                begin
                  temp:=Queue.Name.LookNext;
                  if ( (LowerCase(ExtractFileExt(temp_n))='.mp3') or (not MP3_only) )
                    then
                      begin
                        if CheckBox4.Checked
                          then temp:=Perevod_v_Kirillicu(temp);
                        if CheckBox5.Checked
                          then WriteLn(MPL, concat(Group_Name, temp))
                          else WriteLn(MPL, temp);
                      end;
                end;
            end;
        end
      else
        begin
          MessageBox(Application.Handle, PAnsiChar('.    '+MPL_Path+'.'), PAnsiChar('copy_m3u_2_flash'), 0);
          bang:=false;
        end;
    CloseFile(MPL);
  end;   //   - *.mpl
if bang then
  begin
    Form1.Label5.Caption:=', .   .';
    Form1.Repaint;
    Form1.Enabled:=false;
  end;
Queue.Path.ResetLook;
Queue.Name.ResetLook;
while (( not Queue.Path.LookEnd ) and (bang) )do
  begin
    temp:=Queue.Path.LookNext;
    temp_n:=Queue.Name.LookNext;
    if temp<>'!!!'
      then
        if ( (LowerCase(ExtractFileExt(temp_n))='.mp3') or (not MP3_only) )
        then
          begin
            New_File_Path:=DirPath;
            if CheckBox4.Checked
              then temp_n:=Perevod_v_Kirillicu(temp_n);
            if CheckBox5.Checked then temp_n:=concat(Group_Name, temp_n);
            New_File_Path:=Concat(New_File_Path, temp_n);
            fail:=false;
            CopyFile(PAnsiChar(temp), PAnsiChar(New_File_Path), fail);
            Form1.Label6.Caption:=copy_process+temp;
            Form1.Repaint;
            if fail
              then MessageBox(Application.Handle, PAnsiChar(Oshibka+temp), 'copy_m3y_2_flash', mb_ok);
          end;
  end;
if bang then
  begin
    Form1.Label5.Caption:='';
    Form1.Label6.Caption:='';
    Form1.Enabled:=true;
    Form1.Button2.Click;
    DirPath:=backup_DirPath;
  end;
end;

procedure TForm1.CheckBox3Click(Sender: TObject);
begin
MP3_only:=Form1.CheckBox3.Checked;
Move_to_table;
end;

procedure TForm1.Button7Click(Sender: TObject);
begin
Form1.Enabled:=false;
AboutBox.Visible:=true;
end;

end.
